----------------------------------------------------------------------------
-- Create all database objects for TM-DB    
-- Database system: DB2 for LUW, version 9.1
----------------------------------------------------------------------------

set schema speedgtm;

------- Create ServerTable (defines the number of MPS per class) -----------
create table servertable (
    server 	varchar(80) NOT NULL,
    class 	SMALLINT NOT NULL DEFAULT 0,
    mps 	SMALLINT,
    PRIMARY KEY (SERVER, CLASS)
);


------- Create SpaTable (contains the Scratch Pad Area) --------------------
create table spatable (
    terminal 	varchar(8) NOT NULL,
    transaction varchar(8) NOT NULL,
    spa 		blob inline length 3900,
    PRIMARY KEY (terminal, transaction)
);

------- Create MessageTable (for logging purposes if enabled) --------------
create table messagetable (
    code 			char(1),
    ts_insertion 	timestamp,
    trx_name 		varchar(8),
    user_id			varchar(8),
    lterm 			varchar(8),
    client_id 		varchar(8),
    mfs_name 		varchar(8),
    message 		blob inline length 3900 --size of byte buffer that carries the message
);


------- Create StageTable (config for transactions) ------------------------
create table stagetable (
	transaction varchar(8) NOT NULL PRIMARY KEY,
	program 	varchar(8),
	spasize 	int NOT NULL DEFAULT 0,
	class 		smallint NOT NULL DEFAULT 0,
);