----------------------------------------------------------------------------
-- Create all database objects for TM-DB    
-- Database system: Oracle 10 or later
----------------------------------------------------------------------------

alter session set current_schema=trxeng;

------- Create ServerTable (defines the number of MPS per class) -----------
create table servertable(
    server 	varchar2(80) not null,
    class 	smallint default 0 not null,
    mps 	smallint,
    CONSTRAINT PKSERVERTABLE PRIMARY KEY (server, class)
 );


------- Create SpaTable (contains the Scratch Pad Area) --------------------
create table spatable(
    terminal 	varchar2(8) NOT NULL,
    transaction varchar2(8) NOT NULL,
    spa 		LONG RAW,
    CONSTRAINT PKSTAGE PRIMARY KEY (terminal, transaction)
);

------- Create MessageTable (for logging purposes if enabled) --------------
create table messagetable (
	code 			char(1),
    ts_insertion 	timestamp,
    trx_name 		varchar2(8),
    user_id 		varchar2(8),
    lterm 			varchar2(8),
    client_id 		varchar2(8),
    mfs_name 		varchar2(8),
    message 		blob
);


------- Create StageTable (config for transactions) ------------------------
create table stagetable (
    program 	varchar2(8),
    transaction varchar2(8) NOT NULL,
    spasize 	int default 0 not null,
    class 		smallint default 0 not null,
    CONSTRAINT PKSTAGETABLE PRIMARY KEY (transaction)
 );