----------------------------------------------------------------------------
-- Create all database objects for TM-DB    
-- Database system: Postgresql
----------------------------------------------------------------------------

create schema trxeng;

------- Create StageTable (config for transactions) ------------------------
CREATE TABLE trxeng.stagetable (
	"program" varchar(8) NULL,
	"transaction" varchar(8) NOT NULL,
	spasize int4 NOT NULL DEFAULT 0,
	"class" int2 NOT NULL DEFAULT 0,
	CONSTRAINT pkstagetable PRIMARY KEY (transaction)
);

------- Create SpaTable (contains the Scratch Pad Area) --------------------
CREATE TABLE trxeng.spatable (
	terminal varchar(8) NOT NULL,
	"transaction" varchar(8) NOT NULL,
	spa bytea NULL,
	CONSTRAINT pkstage PRIMARY KEY (terminal, transaction)
);

------- Create ServerTable (defines the number of MPS per class) ----------
CREATE TABLE trxeng.servertable (
	"server" varchar(80) NOT NULL,
	"class" int2 NOT NULL DEFAULT 0,
	mps int2 NULL,
	CONSTRAINT pkservertable PRIMARY KEY (server, class)
);

------- Create MessageTable (for logging purposes if enabled) --------------
CREATE TABLE trxeng.messagetable (
	code bpchar(1) NULL,
	ts_insertion timestamp NULL,
	trx_name varchar(8) NULL,
	user_id varchar(8) NULL,
	lterm varchar(8) NULL,
	client_id varchar(8) NULL,
	mfs_name varchar(8) NULL,
	message bytea NULL
);